Subject: Re: heads up: some practical DNS real life things you might want to know

From: Florian Weimer <[email-masked]>
Date: Tue, 13 Mar 2007 13:39:16 +0100

* bert hubert:

> 1) Mandatory compression
> There are domestic routers out there that proxy DNS queries, so computers
> behind it configure the router as their nameserver. In the course of
> migrating a large access provider to the PowerDNS recursor, the helpdesk
> received a slow trickle of calls from owners of certain brands of router who
> lost the ability to resolve domains, and hence use the internet.
>
> A long period of study later it was discovered a recent change in PowerDNS
> disabled compression of the first DNS answer against the original question,
> and that these routers consider 'c0 0c' to be a magic 'Start of Answer'
> marker. And crash when they can't find it.

I've just had a brief look at the source code of such a DNS proxy.
Besides tons of buffer overflows, it only honored the lower 8 bits of
the compression offset.  It's likely that it doesn't affect the answer
section even if you don't special-code this case in the resolver code,
but with CNAME chaining, you really can't be sure. *sigh*

--
to unsubscribe send a message to [email-masked] with
the word 'unsubscribe' in a single line as the message text body.
archive: <http://ops.ietf.org/lists/namedroppers/>